#ifndef XJUMP_H_
#define XJUMP_H_

typedef struct{
	int x;
	int y;
	int vx;
	int vy;
	int dir;
	int jump;

	int pic;
	int g_count;

	int erase_x;
	int erase_y;
}hero_t;


typedef struct{
	int graphic;
	int graphic_base;

	int floor;

	int y;

	int left;
	int right;

	int left_prev;

	int erase_x;
	int erase_y;
	int erase_width;

	int left_src;
	int right_src;

	int mu;

	/* moving */

	int move_vector;

	/* blink */

	int blink_interval;
	int blink_count;

	/* force */

	int force_vector;

	/* graphic phase */

	int phase;
}floor_t;

typedef struct{
	int floor;
	int level;
	int seed;
	unsigned char *data;
	time_t time;
	int size;
}log_t;

#define FLOOR_CLEAR	0
#define FLOOR_NORMAL	1
#define FLOOR_ICE	2
#define FLOOR_FORCE	3

#define WIDTH		32
#define HEIGHT		24
#define FLOOR_HEIGHT	5

#define KEY_UP	  1
#define KEY_RIGHT 2
#define KEY_LEFT  4



void FLOOR_draw( floor_t *fp );
void FLOOR_refresh( void );
void FLOOR_create( int y );
void FLOOR_move( floor_t *fp, int scroll );
void FLOOR_move_all( int scroll );
floor_t *FLOOR_check(int hx, int hy);
void FLOOR_init( int level );


void GAME_init( int level );
int GAME_main( int key );
int GAME_key_press( int key );
int GAME_key_release( int key );

void LOG_init( void );
void LOG_start_write( log_t *p );
void LOG_start_read( log_t *p );
int LOG_write( int key );
int LOG_read( void );
void LOG_check_broken( log_t *p );

extern char *Myname;

#endif
